=begin
------------------------------------------------------------------------
Copyright 2007, TIG (c)
Permission to use, copy, modify, and distribute this software for any 
purpose, and currently without fee, is hereby granted, provided that  
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.
------------------------------------------------------------------------
Name        : Roof.rb
Author      : TIG
Description : A set of Roof Making Tools.
Menu Item   : Plugins > Roof... > Sub-Menus...
Usage       : See RoofHelp.mht file originally distributed with this.
Version     : 1.0	20070824	First issue.
			  1.1	20070826	A:B slope glitch fixed: array.to_f !
			  1.2	20070827	Rectangle checking OK =~ 90 degrees.
			  1.3	20070828	Fixed Gable Materials messed up by v1.2,
								gable 2 overhang glitches & spurious
								non-rectanglur face errors.
------------------------------------------------------------------------
=end
eval %q{PWJlZ2luClNldmVyYWwgcGFydHMgYXJlIGluc3BpcmVkIGluIHBhcnQgYnkg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}.unpack("m").to_s